#define _GNU_SOURCE
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <dirent.h>
#include <unistd.h>
#include <errno.h>
using namespace std;

int check_mail(const char* fname)
{
 FILE *f = fopen(fname,"r");
 if (!f) {
  cout << "Nelze otevrit " << fname << ": " << strerror(errno) << "\n";
  return 0;
 }
 int nmesg = 0;
 char buf[512];
 while (fgets(buf,512,f)) {
  if (strncmp(buf,"From ",5) == 0) {
   int len = strlen(buf);
   int i;
   for (i=5; i<len; i++) {
    if (buf[i] == ' ') {
     break;
    }
   }
   while (buf[++i] == ' ');
   if (i != 5 && i != len) {
    char *cas_str = buf+i;
    if (cas_str[strlen(cas_str)-1] == '\n')
     cas_str[strlen(cas_str)-1] = 0;
    struct tm cas;
    memset(&cas,0,sizeof(cas));
    if (strptime(cas_str,"%a %b %e %T %Y",&cas)) {
     nmesg++;
     while (fgets(buf,512,f)) {
      if (strcmp(buf,"\n") == 0) {
       break;
      }
      if (strncasecmp(buf,"Status: ",8) == 0) {
       i = 7;
       while (buf[++i] == ' ');
       char *status = buf+i;
       if (status[strlen(status)-1] == '\n')
	status[strlen(status)-1] = 0;
       len = strlen(status);
       for (i=0;i<len;i++) {
	if ((status[i] | 32) == 'r') {
	 nmesg--;
	 break;
	}
       }
      }
     }
    }
   }
  }
 }
 return nmesg;
}

int main(int argc, char *argv[])
{
 DIR* dp;
 dirent* ep;
 char *maildir = 0;
 {
  const char* home;
  if (!(home = getenv("HOME"))) {
   cerr << "Nemas home???\n";
   return -1;
  }
  maildir = (char*) malloc(strlen(home) + 10);
  if (!maildir) {
   cerr << "Chyba malloc\n";
   return -1;
  }
  strcpy(maildir,home);
  strcat(maildir,"/Mail");
 }
 dp = opendir(maildir);
 if (!dp) {
  cout << "Nenasel jsem ~/Mail !!!\n";
 } else {
  while ((ep = readdir(dp))) {
   if (ep->d_type & DT_REG) {
    char *fname = (char*) malloc(strlen(maildir) + _D_EXACT_NAMLEN(ep) + 2);
    if (!fname) {
     cerr << "Chyba malloc\n";
     if (maildir) free(maildir);
     return -1;
    }
    strcpy(fname,maildir);
    strcat(fname,"/");
    strcat(fname,ep->d_name);
    int pocet = check_mail(fname);
    if (pocet) {
     cout << "Mas " << pocet << " " << ({
      char* ret;
      if (pocet == 1) {
       ret = "novy mail";
      } else if (pocet>1 && pocet<5) {
       ret = "nove maily";
      } else {
       ret = "novych mailu";
      }
      ret;
     }) << " v =" << ep->d_name << "\n";
    }
    if (fname) free(fname);
   }
  }
  closedir(dp);
 }
 if (maildir) free(maildir);
 char *spool;
 if ((spool = getenv("MAIL"))) {
  int pocet = check_mail(spool);
  if (pocet) {
   cout << "Mas " << pocet << " " << ({
    char* ret;
    if (pocet == 1) {
     ret = "novy mail";
    } else if (pocet>1 && pocet<5) {
     ret = "nove maily";
    } else {
     ret = "novych mailu";
    }
    ret;
   }) << " v " << spool << "\n";
  }
 }
}
